SystemOrganization addCategory: #ConfigurationOfAcceptit!

Object subclass: #ConfigurationOfAcceptit
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfAcceptit'!

!ConfigurationOfAcceptit commentStamp: 'topa 3/11/2011 23:11' prior: 0!
Copy me to create a new configuration or edit and evaluate the following doits.

        "Create configuration class and initial baseline method"

        MetacelloToolBox 
                createBaseline: '1.0-baseline'
                for: 'Acceptit'
                repository: 'http://www.hpi.uni-potsdam.de/hirschfeld/squeaksource/acceptit'
                requiredProjects: #()
                packages: #('acceptit-Core' 'acceptit-GUI' 'acceptit-Libraries' 'acceptit-Tests')
                dependencies:
                        {'acceptit-Tests' -> #('acceptit-Libraries') .
				 'acceptit-GUI' -> #('acceptit-Core') .
				 'acceptit-Libraries' -> #('acceptit-Core')
				}
                groups:
                        {('default' -> #('Core' 'GUI')).
                        ('Core' -> #('acceptit-Core' 'acceptit-Libraries')).
				('GUI' ->  #('acceptit-GUI')).
                        ('Tests' -> #('acceptit-Tests'))}.

	   "create initial development method from the baseline"

         MetacelloToolBox
               createDevelopment: '1.0'
               for: 'Acceptit'
                importFromBaseline: '1.0-baseline'
                description: 'initial version'.
!

!ConfigurationOfAcceptit class methodsFor: 'development support' stamp: 'topa 3/11/2011 23:00'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfAcceptit class methodsFor: 'private' stamp: 'topa 3/11/2011 23:00'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfAcceptit class methodsFor: 'private' stamp: 'topa 3/11/2011 23:00'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfAcceptit class methodsFor: 'private' stamp: 'topa 3/11/2011 23:00'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfAcceptit class methodsFor: 'metacello tool support' stamp: 'topa 3/11/2011 23:00'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfAcceptit class methodsFor: 'loading' stamp: 'topa 3/11/2011 23:00'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfAcceptit class methodsFor: 'loading' stamp: 'topa 3/11/2011 23:00'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfAcceptit class methodsFor: 'loading' stamp: 'topa 3/11/2011 23:00'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfAcceptit class methodsFor: 'accessing' stamp: 'topa 3/11/2011 23:00'!
project

	^self new project! !

!ConfigurationOfAcceptit class methodsFor: 'development support' stamp: 'topa 3/11/2011 23:00'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfAcceptit methodsFor: 'baselines' stamp: 'topa 3/17/2011 18:26'!
baseline10: spec
	<version: '1.0-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.
		spec repository: 'http://www.hpi.uni-potsdam.de/hirschfeld/squeaksource/acceptit'.
		spec 
			package: 'acceptit-Core';
			package: 'acceptit-GUI' with: [
				spec requires: #('acceptit-Core' ). ];
			package: 'acceptit-Libraries' with: [
				spec requires: #('acceptit-Core' ). ];
			package: 'acceptit-Tests' with: [
				spec requires: #('acceptit-Libraries' )];
			package: 'STTutTodoApp' with: [
				spec requires: #('acceptit-Libraries' )].
		spec 
			group: 'default' with: #('Core' 'GUI' );
			group: 'Core' with: #('acceptit-Core' 'acceptit-Libraries' );
			group: 'GUI' with: #('acceptit-GUI' );
			group: 'Tests' with: #('acceptit-Tests' );
			group: 'Demo' with: #('default' 'Tests' 'STTutTodoApp')].
! !

!ConfigurationOfAcceptit methodsFor: 'symbolic versions' stamp: 'topa 3/11/2011 23:11'!
development: spec
	<symbolicVersion: #'development'>

	spec for: #'common' version: '1.0'.
! !

!ConfigurationOfAcceptit methodsFor: 'accessing' stamp: 'topa 3/11/2011 23:00'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self.
		project := constructor project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfAcceptit methodsFor: 'versions' stamp: 'topa 3/17/2011 18:26'!
version10: spec
	<version: '1.0' imports: #('1.0-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'development'.
		spec description: 'initial version'.
		spec author: 'topa'.
		spec timestamp: '3/11/2011 23:11'.
		spec 
			package: 'acceptit-Core' with: 'acceptit-Core-topa.1';
			package: 'acceptit-GUI' with: 'acceptit-GUI-topa.1';
			package: 'acceptit-Libraries' with: 'acceptit-Libraries-topa.1';
			package: 'acceptit-Tests' with: 'acceptit-Tests-topa.1';
			package: 'STTutTodoApp' with: 'STTutTodoApp-topa.16'].
! !
